
_set_up:

;HC_SR04.c,8 :: 		void set_up() {
;HC_SR04.c,9 :: 		DDB0_bit =1;
	IN         R27, DDB0_bit+0
	SBR        R27, BitMask(DDB0_bit+0)
	OUT        DDB0_bit+0, R27
;HC_SR04.c,10 :: 		DDB1_bit =0;
	IN         R27, DDB1_bit+0
	CBR        R27, BitMask(DDB1_bit+0)
	OUT        DDB1_bit+0, R27
;HC_SR04.c,11 :: 		PORTB0_bit=0;
	IN         R27, PORTB0_bit+0
	CBR        R27, BitMask(PORTB0_bit+0)
	OUT        PORTB0_bit+0, R27
;HC_SR04.c,12 :: 		DDC2_bit=1;  //DATA
	IN         R27, DDC2_bit+0
	SBR        R27, BitMask(DDC2_bit+0)
	OUT        DDC2_bit+0, R27
;HC_SR04.c,13 :: 		PORTC2_bit=0;
	IN         R27, PORTC2_bit+0
	CBR        R27, BitMask(PORTC2_bit+0)
	OUT        PORTC2_bit+0, R27
;HC_SR04.c,14 :: 		DDC1_bit=1; //CLK
	IN         R27, DDC1_bit+0
	SBR        R27, BitMask(DDC1_bit+0)
	OUT        DDC1_bit+0, R27
;HC_SR04.c,15 :: 		PORTC1_bit=0;
	IN         R27, PORTC1_bit+0
	CBR        R27, BitMask(PORTC1_bit+0)
	OUT        PORTC1_bit+0, R27
;HC_SR04.c,16 :: 		TCCR1A = 0x00;
	LDI        R27, 0
	STS        TCCR1A+0, R27
;HC_SR04.c,17 :: 		TCCR1B |=(1<<CS11);
	LDS        R27, TCCR1B+0
	SBR        R27, 2
	STS        TCCR1B+0, R27
;HC_SR04.c,18 :: 		}
L_end_set_up:
	RET
; end of _set_up

_HCSR04_TRIGGER:

;HC_SR04.c,20 :: 		void HCSR04_TRIGGER ()
;HC_SR04.c,22 :: 		PORTB0_bit=1;
	IN         R27, PORTB0_bit+0
	SBR        R27, BitMask(PORTB0_bit+0)
	OUT        PORTB0_bit+0, R27
;HC_SR04.c,23 :: 		delay_us(10);
	LDI        R16, 53
L_HCSR04_TRIGGER0:
	DEC        R16
	BRNE       L_HCSR04_TRIGGER0
	NOP
;HC_SR04.c,24 :: 		PORTB0_bit=0;
	IN         R27, PORTB0_bit+0
	CBR        R27, BitMask(PORTB0_bit+0)
	OUT        PORTB0_bit+0, R27
;HC_SR04.c,25 :: 		}
L_end_HCSR04_TRIGGER:
	RET
; end of _HCSR04_TRIGGER

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;HC_SR04.c,26 :: 		void main() {
;HC_SR04.c,27 :: 		set_up();
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	CALL       _set_up+0
;HC_SR04.c,28 :: 		TM1637_SetBrightness(7);
	LDI        R27, 7
	MOV        R2, R27
	CALL       _TM1637_SetBrightness+0
;HC_SR04.c,29 :: 		TM1637_Init();
	CALL       _TM1637_Init+0
;HC_SR04.c,30 :: 		while (1)  {
L_main2:
;HC_SR04.c,31 :: 		HCSR04_TRIGGER();
	CALL       _HCSR04_TRIGGER+0
;HC_SR04.c,32 :: 		while((PINB&(1<<1))==0);
L_main4:
	IN         R16, PINB+0
	ANDI       R16, 2
	CPI        R16, 0
	BREQ       L__main13
	JMP        L_main5
L__main13:
	JMP        L_main4
L_main5:
;HC_SR04.c,33 :: 		TCNT1H=0;
	LDI        R27, 0
	STS        TCNT1H+0, R27
;HC_SR04.c,34 :: 		TCNT1L=0;
	LDI        R27, 0
	STS        TCNT1L+0, R27
;HC_SR04.c,35 :: 		while(PINB&(1<<1));
L_main6:
	IN         R16, PINB+0
	SBRS       R16, 1
	JMP        L_main7
	JMP        L_main6
L_main7:
;HC_SR04.c,36 :: 		cnt = TCNT1L;
	LDS        R16, TCNT1L+0
	STS        _cnt+0, R16
	LDI        R27, 0
	STS        _cnt+1, R27
;HC_SR04.c,37 :: 		cnt |= TCNT1H<<8;
	LDS        R16, TCNT1H+0
	MOV        R19, R16
	CLR        R18
	LDS        R16, _cnt+0
	LDS        R17, _cnt+1
	OR         R16, R18
	OR         R17, R19
	STS        _cnt+0, R16
	STS        _cnt+1, R17
;HC_SR04.c,38 :: 		tiempo =(cnt)*0.5;
	LDI        R18, 0
	MOV        R19, R18
	CALL       _float_ulong2fp+0
	LDI        R20, 0
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 63
	CALL       _float_fpmul1+0
	CALL       _float_fpint+0
	STS        _tiempo+0, R16
	STS        _tiempo+1, R17
	STS        _tiempo+2, R18
	STS        _tiempo+3, R19
;HC_SR04.c,39 :: 		distancia =tiempo/58;
	LDI        R20, 58
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	STS        _distancia+0, R16
	STS        _distancia+1, R17
	STS        _distancia+2, R18
	STS        _distancia+3, R19
;HC_SR04.c,40 :: 		TM1637_DisplayDecimal(distancia, 0); // 0: OFF 1: ON
	CLR        R6
	MOVW       R2, R16
	MOVW       R4, R18
	CALL       _TM1637_DisplayDecimal+0
;HC_SR04.c,41 :: 		delay_ms(1000);
	LDI        R18, 82
	LDI        R17, 43
	LDI        R16, 0
L_main8:
	DEC        R16
	BRNE       L_main8
	DEC        R17
	BRNE       L_main8
	DEC        R18
	BRNE       L_main8
	NOP
	NOP
	NOP
	NOP
;HC_SR04.c,42 :: 		}
	JMP        L_main2
;HC_SR04.c,43 :: 		}
L_end_main:
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
